var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};

// src/Callout.tsx
import * as React from "react";
import PropTypes from "prop-types";
import { Box, safelySpreadBoxProps } from "@twilio-paste/box";
import { ErrorIcon } from "@twilio-paste/icons/esm/ErrorIcon";
import { NeutralIcon } from "@twilio-paste/icons/esm/NeutralIcon";
import { NewIcon } from "@twilio-paste/icons/esm/NewIcon";
import { ScreenReaderOnly } from "@twilio-paste/screen-reader-only";
import { SuccessIcon } from "@twilio-paste/icons/esm/SuccessIcon";
import { WarningIcon } from "@twilio-paste/icons/esm/WarningIcon";
import { isMarginTokenProp } from "@twilio-paste/style-props";
var variantStyles = {
  success: {
    backgroundColor: "colorBackgroundSuccessWeakest",
    color: "colorTextSuccess",
    borderColor: "colorBorderSuccessWeaker"
  },
  error: {
    backgroundColor: "colorBackgroundErrorWeakest",
    color: "colorTextError",
    borderColor: "colorBorderErrorWeaker"
  },
  warning: {
    backgroundColor: "colorBackgroundWarningWeakest",
    color: "colorTextWarningStrong",
    borderColor: "colorBorderWarningWeaker"
  },
  new: {
    backgroundColor: "colorBackgroundNewWeakest",
    color: "colorTextNew",
    borderColor: "colorBorderNewWeaker"
  },
  neutral: {
    backgroundColor: "colorBackgroundNeutralWeakest",
    color: "colorTextNeutral",
    borderColor: "colorBorderNeutralWeaker"
  }
};
var variantIcons = {
  success: /* @__PURE__ */ React.createElement(SuccessIcon, { decorative: true, color: "colorTextIconSuccess" }),
  error: /* @__PURE__ */ React.createElement(ErrorIcon, { decorative: true, color: "colorTextIconError" }),
  warning: /* @__PURE__ */ React.createElement(WarningIcon, { decorative: true, color: "colorTextIconWarning" }),
  new: /* @__PURE__ */ React.createElement(NewIcon, { decorative: true, color: "colorTextIconNew" }),
  neutral: /* @__PURE__ */ React.createElement(NeutralIcon, { decorative: true, color: "colorTextIconNeutral" })
};
var defaultIconLabels = {
  success: "(success)",
  error: "(error)",
  warning: "(warning)",
  new: "(new)",
  neutral: "(information)"
};
var Callout = React.forwardRef(
  (_a, ref) => {
    var _b = _a, { children, variant, element = "CALLOUT", i18nLabel, marginY } = _b, props = __objRest(_b, ["children", "variant", "element", "i18nLabel", "marginY"]);
    const IconComponent = variantIcons[variant];
    const iconLabel = i18nLabel ? i18nLabel : defaultIconLabels[variant];
    return /* @__PURE__ */ React.createElement(
      Box,
      __spreadValues(__spreadProps(__spreadValues({}, safelySpreadBoxProps(props)), {
        ref,
        element,
        display: "flex",
        marginY,
        padding: "space60",
        borderStyle: "solid",
        borderWidth: "borderWidth10",
        borderRadius: "borderRadius30",
        variant
      }), variantStyles[variant]),
      /* @__PURE__ */ React.createElement(Box, { marginRight: "space60", paddingTop: "space10", element: `${element}_ICON` }, IconComponent, /* @__PURE__ */ React.createElement(ScreenReaderOnly, null, iconLabel)),
      /* @__PURE__ */ React.createElement(Box, { display: "flex", flexDirection: "column", rowGap: "space50", flex: "1" }, children)
    );
  }
);
Callout.displayName = "Callout";
Callout.propTypes = {
  children: PropTypes.node,
  element: PropTypes.string,
  variant: PropTypes.oneOf(["neutral", "warning", "error", "success", "new", "default"]).isRequired,
  i18nLabel: PropTypes.string,
  marginY: isMarginTokenProp
};

// src/CalloutHeading.tsx
import * as React2 from "react";
import PropTypes2 from "prop-types";
import { Text, safelySpreadTextProps } from "@twilio-paste/text";
var CalloutHeading = React2.forwardRef(
  (_a, ref) => {
    var _b = _a, { element = "CALLOUT_HEADING", children, as = "h3" } = _b, props = __objRest(_b, ["element", "children", "as"]);
    return /* @__PURE__ */ React2.createElement(
      Text,
      __spreadProps(__spreadValues({}, safelySpreadTextProps(props)), {
        as,
        ref,
        element,
        color: "currentColor",
        lineHeight: "lineHeight40",
        fontWeight: "fontWeightSemibold"
      }),
      children
    );
  }
);
CalloutHeading.displayName = "CalloutHeading";
CalloutHeading.propTypes = {
  children: PropTypes2.node,
  element: PropTypes2.string,
  as: PropTypes2.oneOf(["h1", "h2", "h3", "h4", "h5", "h6", "div", "label", "span", "header"]).isRequired
};

// src/CalloutList.tsx
import * as React3 from "react";
import PropTypes3 from "prop-types";
import { Box as Box2, safelySpreadBoxProps as safelySpreadBoxProps2 } from "@twilio-paste/box";
import { Text as Text2, safelySpreadTextProps as safelySpreadTextProps2 } from "@twilio-paste/text";
var CalloutList = React3.forwardRef(
  (_a, ref) => {
    var _b = _a, { element = "CALLOUT_LIST", children, as } = _b, props = __objRest(_b, ["element", "children", "as"]);
    return /* @__PURE__ */ React3.createElement(
      Box2,
      __spreadProps(__spreadValues({}, safelySpreadBoxProps2(props)), {
        element,
        ref,
        as,
        margin: "space0",
        display: "flex",
        flexDirection: "column",
        rowGap: "space30",
        paddingLeft: "space60"
      }),
      children
    );
  }
);
CalloutList.displayName = "CalloutList";
CalloutList.propTypes = {
  children: PropTypes3.node,
  element: PropTypes3.string,
  as: PropTypes3.oneOf(["ul", "ol"]).isRequired
};
var CalloutListItem = React3.forwardRef(
  (_a, ref) => {
    var _b = _a, { element = "CALLOUT_LIST_ITEM", children } = _b, props = __objRest(_b, ["element", "children"]);
    return /* @__PURE__ */ React3.createElement(Text2, __spreadProps(__spreadValues({}, safelySpreadTextProps2(props)), { element, ref, as: "li", color: "currentColor" }), children);
  }
);
CalloutListItem.displayName = "CalloutListItem";
CalloutListItem.propTypes = {
  children: PropTypes3.node,
  element: PropTypes3.string
};

// src/CalloutText.tsx
import * as React4 from "react";
import PropTypes4 from "prop-types";
import { Text as Text3, safelySpreadTextProps as safelySpreadTextProps3 } from "@twilio-paste/text";
var CalloutText = React4.forwardRef(
  (_a, ref) => {
    var _b = _a, { element = "CALLOUT_TEXT", children } = _b, props = __objRest(_b, ["element", "children"]);
    return /* @__PURE__ */ React4.createElement(
      Text3,
      __spreadProps(__spreadValues({}, safelySpreadTextProps3(props)), {
        as: "p",
        ref,
        element,
        color: "currentColor",
        lineHeight: "lineHeight40"
      }),
      children
    );
  }
);
CalloutText.displayName = "CalloutText";
CalloutText.propTypes = {
  children: PropTypes4.node,
  element: PropTypes4.string
};
export {
  Callout,
  CalloutHeading,
  CalloutList,
  CalloutListItem,
  CalloutText
};
