"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.tsx
var src_exports = {};
__export(src_exports, {
  Callout: () => Callout,
  CalloutHeading: () => CalloutHeading,
  CalloutList: () => CalloutList,
  CalloutListItem: () => CalloutListItem,
  CalloutText: () => CalloutText
});
module.exports = __toCommonJS(src_exports);

// src/Callout.tsx
var React = __toESM(require("react"));
var import_prop_types = __toESM(require("prop-types"));
var import_box = require("@twilio-paste/box");
var import_ErrorIcon = require("@twilio-paste/icons/cjs/ErrorIcon");
var import_NeutralIcon = require("@twilio-paste/icons/cjs/NeutralIcon");
var import_NewIcon = require("@twilio-paste/icons/cjs/NewIcon");
var import_screen_reader_only = require("@twilio-paste/screen-reader-only");
var import_SuccessIcon = require("@twilio-paste/icons/cjs/SuccessIcon");
var import_WarningIcon = require("@twilio-paste/icons/cjs/WarningIcon");
var import_style_props = require("@twilio-paste/style-props");
var variantStyles = {
  success: {
    backgroundColor: "colorBackgroundSuccessWeakest",
    color: "colorTextSuccess",
    borderColor: "colorBorderSuccessWeaker"
  },
  error: {
    backgroundColor: "colorBackgroundErrorWeakest",
    color: "colorTextError",
    borderColor: "colorBorderErrorWeaker"
  },
  warning: {
    backgroundColor: "colorBackgroundWarningWeakest",
    color: "colorTextWarningStrong",
    borderColor: "colorBorderWarningWeaker"
  },
  new: {
    backgroundColor: "colorBackgroundNewWeakest",
    color: "colorTextNew",
    borderColor: "colorBorderNewWeaker"
  },
  neutral: {
    backgroundColor: "colorBackgroundNeutralWeakest",
    color: "colorTextNeutral",
    borderColor: "colorBorderNeutralWeaker"
  }
};
var variantIcons = {
  success: /* @__PURE__ */ React.createElement(import_SuccessIcon.SuccessIcon, { decorative: true, color: "colorTextIconSuccess" }),
  error: /* @__PURE__ */ React.createElement(import_ErrorIcon.ErrorIcon, { decorative: true, color: "colorTextIconError" }),
  warning: /* @__PURE__ */ React.createElement(import_WarningIcon.WarningIcon, { decorative: true, color: "colorTextIconWarning" }),
  new: /* @__PURE__ */ React.createElement(import_NewIcon.NewIcon, { decorative: true, color: "colorTextIconNew" }),
  neutral: /* @__PURE__ */ React.createElement(import_NeutralIcon.NeutralIcon, { decorative: true, color: "colorTextIconNeutral" })
};
var defaultIconLabels = {
  success: "(success)",
  error: "(error)",
  warning: "(warning)",
  new: "(new)",
  neutral: "(information)"
};
var Callout = React.forwardRef(
  (_a, ref) => {
    var _b = _a, { children, variant, element = "CALLOUT", i18nLabel, marginY } = _b, props = __objRest(_b, ["children", "variant", "element", "i18nLabel", "marginY"]);
    const IconComponent = variantIcons[variant];
    const iconLabel = i18nLabel ? i18nLabel : defaultIconLabels[variant];
    return /* @__PURE__ */ React.createElement(
      import_box.Box,
      __spreadValues(__spreadProps(__spreadValues({}, (0, import_box.safelySpreadBoxProps)(props)), {
        ref,
        element,
        display: "flex",
        marginY,
        padding: "space60",
        borderStyle: "solid",
        borderWidth: "borderWidth10",
        borderRadius: "borderRadius30",
        variant
      }), variantStyles[variant]),
      /* @__PURE__ */ React.createElement(import_box.Box, { marginRight: "space60", paddingTop: "space10", element: `${element}_ICON` }, IconComponent, /* @__PURE__ */ React.createElement(import_screen_reader_only.ScreenReaderOnly, null, iconLabel)),
      /* @__PURE__ */ React.createElement(import_box.Box, { display: "flex", flexDirection: "column", rowGap: "space50", flex: "1" }, children)
    );
  }
);
Callout.displayName = "Callout";
Callout.propTypes = {
  children: import_prop_types.default.node,
  element: import_prop_types.default.string,
  variant: import_prop_types.default.oneOf(["neutral", "warning", "error", "success", "new", "default"]).isRequired,
  i18nLabel: import_prop_types.default.string,
  marginY: import_style_props.isMarginTokenProp
};

// src/CalloutHeading.tsx
var React2 = __toESM(require("react"));
var import_prop_types2 = __toESM(require("prop-types"));
var import_text = require("@twilio-paste/text");
var CalloutHeading = React2.forwardRef(
  (_a, ref) => {
    var _b = _a, { element = "CALLOUT_HEADING", children, as = "h3" } = _b, props = __objRest(_b, ["element", "children", "as"]);
    return /* @__PURE__ */ React2.createElement(
      import_text.Text,
      __spreadProps(__spreadValues({}, (0, import_text.safelySpreadTextProps)(props)), {
        as,
        ref,
        element,
        color: "currentColor",
        lineHeight: "lineHeight40",
        fontWeight: "fontWeightSemibold"
      }),
      children
    );
  }
);
CalloutHeading.displayName = "CalloutHeading";
CalloutHeading.propTypes = {
  children: import_prop_types2.default.node,
  element: import_prop_types2.default.string,
  as: import_prop_types2.default.oneOf(["h1", "h2", "h3", "h4", "h5", "h6", "div", "label", "span", "header"]).isRequired
};

// src/CalloutList.tsx
var React3 = __toESM(require("react"));
var import_prop_types3 = __toESM(require("prop-types"));
var import_box2 = require("@twilio-paste/box");
var import_text2 = require("@twilio-paste/text");
var CalloutList = React3.forwardRef(
  (_a, ref) => {
    var _b = _a, { element = "CALLOUT_LIST", children, as } = _b, props = __objRest(_b, ["element", "children", "as"]);
    return /* @__PURE__ */ React3.createElement(
      import_box2.Box,
      __spreadProps(__spreadValues({}, (0, import_box2.safelySpreadBoxProps)(props)), {
        element,
        ref,
        as,
        margin: "space0",
        display: "flex",
        flexDirection: "column",
        rowGap: "space30",
        paddingLeft: "space60"
      }),
      children
    );
  }
);
CalloutList.displayName = "CalloutList";
CalloutList.propTypes = {
  children: import_prop_types3.default.node,
  element: import_prop_types3.default.string,
  as: import_prop_types3.default.oneOf(["ul", "ol"]).isRequired
};
var CalloutListItem = React3.forwardRef(
  (_a, ref) => {
    var _b = _a, { element = "CALLOUT_LIST_ITEM", children } = _b, props = __objRest(_b, ["element", "children"]);
    return /* @__PURE__ */ React3.createElement(import_text2.Text, __spreadProps(__spreadValues({}, (0, import_text2.safelySpreadTextProps)(props)), { element, ref, as: "li", color: "currentColor" }), children);
  }
);
CalloutListItem.displayName = "CalloutListItem";
CalloutListItem.propTypes = {
  children: import_prop_types3.default.node,
  element: import_prop_types3.default.string
};

// src/CalloutText.tsx
var React4 = __toESM(require("react"));
var import_prop_types4 = __toESM(require("prop-types"));
var import_text3 = require("@twilio-paste/text");
var CalloutText = React4.forwardRef(
  (_a, ref) => {
    var _b = _a, { element = "CALLOUT_TEXT", children } = _b, props = __objRest(_b, ["element", "children"]);
    return /* @__PURE__ */ React4.createElement(
      import_text3.Text,
      __spreadProps(__spreadValues({}, (0, import_text3.safelySpreadTextProps)(props)), {
        as: "p",
        ref,
        element,
        color: "currentColor",
        lineHeight: "lineHeight40"
      }),
      children
    );
  }
);
CalloutText.displayName = "CalloutText";
CalloutText.propTypes = {
  children: import_prop_types4.default.node,
  element: import_prop_types4.default.string
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Callout,
  CalloutHeading,
  CalloutList,
  CalloutListItem,
  CalloutText
});
